---
title: "Vecteurs numériques"
weight: 11
output:
  blogdown::html_page:
    toc: false
    fig_width: 6
    dev: "svg"
---

<script src="/rmarkdown-libs/header-attrs/header-attrs.js"></script>


<div id="création-rapide" class="section level3">
<h3>Création rapide</h3>
<p>Le vecteur de tous les entiers entre l’entier a et l’entier b est créé par l’opérateur <code>:</code>.</p>
<pre class="r"><code>(-3):5</code></pre>
<pre><code>## [1] -3 -2 -1  0  1  2  3  4  5</code></pre>
<p>La fonction <code>seq</code> permet de définir un vecteur de réels espacés régulièrement:</p>
<pre class="r"><code>seq(10,20,length.out=11)</code></pre>
<pre><code>##  [1] 10 11 12 13 14 15 16 17 18 19 20</code></pre>
<pre class="r"><code>seq(10,20,by=2.1)</code></pre>
<pre><code>## [1] 10.0 12.1 14.2 16.3 18.4</code></pre>
<p>La fonction <code>rep</code> permet de répéter un vecteur plusieurs fois:</p>
<pre class="r"><code>rep(1:3,2)</code></pre>
<pre><code>## [1] 1 2 3 1 2 3</code></pre>
<pre class="r"><code>rep(1:3,each=2)</code></pre>
<pre><code>## [1] 1 1 2 2 3 3</code></pre>
</div>
<div id="application-des-fonctions" class="section level3">
<h3>Application des fonctions</h3>
<ul>
<li>L’application des fonctions à des vecteurs retourne en général un vecteur de la même dimension: la fonction est appliquée à chaque élément du vecteur.</li>
</ul>
<pre class="r"><code>exp(0:3)</code></pre>
<pre><code>## [1]  1.000000  2.718282  7.389056 20.085537</code></pre>
<pre class="r"><code>sqrt(1:3)</code></pre>
<pre><code>## [1] 1.000000 1.414214 1.732051</code></pre>
<pre class="r"><code>floor(seq(1,5,by=.3))</code></pre>
<pre><code>##  [1] 1 1 1 1 2 2 2 3 3 3 4 4 4 4</code></pre>
<pre class="r"><code>ceiling(seq(1,5,by=.3))</code></pre>
<pre><code>##  [1] 1 2 2 2 3 3 3 4 4 4 4 5 5 5</code></pre>
<pre class="r"><code>signif(30.341,3)</code></pre>
<pre><code>## [1] 30.3</code></pre>
<pre class="r"><code>round(30.341)</code></pre>
<pre><code>## [1] 30</code></pre>
<pre class="r"><code>round(30.341,2)</code></pre>
<pre><code>## [1] 30.34</code></pre>
<ul>
<li>Certaines fonctions retournent une seule valeur:</li>
</ul>
<pre class="r"><code>sum(1:3)</code></pre>
<pre><code>## [1] 6</code></pre>
<pre class="r"><code>min(1:3)</code></pre>
<pre><code>## [1] 1</code></pre>
<pre class="r"><code>prod(1:3)</code></pre>
<pre><code>## [1] 6</code></pre>
<ul>
<li>Les fonctions pouvant être appliquées à un nombre arbitraire de réels peuvent aussi en général être appliquées à un nombre arbitraire de vecteurs de réels:</li>
</ul>
<pre class="r"><code>sum(1:3,2:9,3)</code></pre>
<pre><code>## [1] 53</code></pre>
<pre class="r"><code>min(1:3,2:10,0)</code></pre>
<pre><code>## [1] 0</code></pre>
<pre class="r"><code>prod(1:3,2:5)</code></pre>
<pre><code>## [1] 720</code></pre>
<ul>
<li>pour obtenir un extremum terme à terme, il faut utiliser une des fonctions <code>pmin</code> ou <code>pmax</code>:</li>
</ul>
<pre class="r"><code>pmin(1:3,2:4,c(0,8,3))</code></pre>
<pre><code>## [1] 0 2 3</code></pre>
<p>les opérateurs binaires d’arithmétique s’appliquent aussi aux vecteurs de même longueur:</p>
<pre class="r"><code>(1:3)+(2:4)*c(3,2,1)-c(9,4,5)^c(2,2,0)</code></pre>
<pre><code>## [1] -74  -8   6</code></pre>
<pre class="r"><code>x=(1:3)
y=(2:4)
z=c(3,2,1)
w=c(9,4,5)
v=c(2,2,0)
x+y*z-w^v</code></pre>
<pre><code>## [1] -74  -8   6</code></pre>
<p>voire aux vecteurs dont les longeurs de l’un est multiple de l’autre.</p>
<pre class="r"><code>(1:3)+2</code></pre>
<pre><code>## [1] 3 4 5</code></pre>
<pre class="r"><code>(1:3)+(1:6)</code></pre>
<pre><code>## [1] 2 4 6 5 7 9</code></pre>
<pre class="r"><code>(1:6)+(1:3)</code></pre>
<pre><code>## [1] 2 4 6 5 7 9</code></pre>
<pre class="r"><code>(1:6)^2</code></pre>
<pre><code>## [1]  1  4  9 16 25 36</code></pre>
<ul>
<li>Exercice
Calculer la somme des racines carrées des 1000 premiers mutiples de 3</li>
</ul>
<hr />
<details>
<summary>
Solution
</summary>
<pre class="r"><code>((1:1000)*3)|&gt;sqrt()|&gt;sum()</code></pre>
<pre><code>## [1] 36541.87</code></pre>
</details>
<hr />
<ul>
<li>Exercice
Créer le vecteur des dix premiers termes de la suite arithmétique de raison 2 et de valeur initiale 3</li>
</ul>
<hr />
<details>
<summary>
Solution
</summary>
<pre class="r"><code>seq(3,by=2,length.out=10)</code></pre>
<pre><code>##  [1]  3  5  7  9 11 13 15 17 19 21</code></pre>
<pre class="r"><code>3+2*(0:9)</code></pre>
<pre><code>##  [1]  3  5  7  9 11 13 15 17 19 21</code></pre>
</details>
<hr />
</div>
<div id="fonctions-de-vecteurs-numériques." class="section level3">
<h3>Fonctions de vecteurs numériques.</h3>
<p>On génère un vecteur aléatoire de longueur 1000.</p>
<pre class="r"><code>x=rnorm(1000,0,1)
plot(x)</code></pre>
<p><img src="/chapter2/children-1/p11_files/figure-html/unnamed-chunk-12-1.svg" width="576" /></p>
<ul>
<li>signe et valeur absolue</li>
</ul>
<pre class="r"><code>sign(-1:1)</code></pre>
<pre><code>## [1] -1  0  1</code></pre>
<pre class="r"><code>abs(-1:1)</code></pre>
<pre><code>## [1] 1 0 1</code></pre>
<p>On calcule les quantiles, l’écart type, la variance empirique, la moyenne de <code>x</code></p>
<pre class="r"><code>quantile(x,probs = c(0,.25,.5,.75,1))</code></pre>
<pre><code>##          0%         25%         50%         75%        100% 
## -3.53688795 -0.59359887  0.01302781  0.73625719  2.87698431</code></pre>
<pre class="r"><code>sd(x)</code></pre>
<pre><code>## [1] 1.013312</code></pre>
<pre class="r"><code>var(x)</code></pre>
<pre><code>## [1] 1.026801</code></pre>
<pre class="r"><code>mean(x)</code></pre>
<pre><code>## [1] 0.04122626</code></pre>
<pre class="r"><code>range(x)</code></pre>
<pre><code>## [1] -3.536888  2.876984</code></pre>
<pre class="r"><code>plot(cumsum(x),type=&#39;l&#39;)</code></pre>
<p><img src="/chapter2/children-1/p11_files/figure-html/unnamed-chunk-15-1.svg" width="576" /></p>
<pre class="r"><code>plot(cumprod(sort(x)),type=&#39;l&#39;)</code></pre>
<p><img src="/chapter2/children-1/p11_files/figure-html/unnamed-chunk-15-2.svg" width="576" /></p>
</div>
<div id="tri-rang-ordre" class="section level3">
<h3>Tri, rang, ordre</h3>
<p>Le tri retourne un vecteur de même taille, mais ordonné.
Le rang indique combien d’éléments sont plus petits ou égal
L’ordre indique la position du premier, du second …</p>
<pre class="r"><code>sort(x,descending=T)
rang(x)
order(x)</code></pre>
</div>
